#ifndef INAVIGATEURMOTS_H
#define INAVIGATEURMOTS_H

#include "mot.h"

#include <iosfwd>
using std::basic_istream;

class SourceInvalide {};
class SourceEpuisee {};


template <class C>
   struct INavigateurMots
   {
      virtual void associer (basic_istream<C> *) = 0;
      virtual mot<C> prochain () = 0;
      virtual ~INavigateurMots () throw()
         { }
   };

template <class C>
   struct FabriqueNavigateurMots
   {
      static INavigateurMots<C> *Creer ();
   };

//
// Serveur  rdiger... DBUT
//


//
// Serveur  rdiger... FIN
//

template <class C>
   INavigateurMots<C> *FabriqueNavigateurMots<C>::Creer ()
      { return new NavigateurMotsImpl <C>; }



#endif
