#ifndef MOT_H
#define MOT_H

#include <string>
using std::basic_string;
#include <ostream>
using std::basic_ostream;

template <class C>
   class mot
   {
   public:
      typedef basic_string<C> str_type;
   private:
      str_type valeur_;
   public:
      mot (const str_type &valeur = str_type())
         : valeur_(valeur)
      {
      }
      const str_type & valeur () const throw()
         { return valeur_; }
      friend basic_ostream<C> & operator<<
         (basic_ostream<C> &os, const mot<C> &m)
      {
         return os << m.valeur ();
      }
      static bool est_admissible(const C car)
         { return true; }
   };

#endif
